Unit FMinU;
                     INTERFACE
{$N+,E+,F+}
USES Kernel;
Type
  FunType = Function(X: RealType): RealType;
  function FMIN(F:FunType; ax,bx,tol : RealType): RealType;

                     IMPLEMENTATION
  FUNCTION Sign(a,b : RealType): RealType;
  begin
     if b <> 0 then sign:= -abs(a) else sign:=abs(a);
  end;

  function FMIN(F:FunType; ax,bx,tol : RealType): RealType;
  var
     a,b,c,d,e,eps,xm,p,q,r,Tol1,Tol2,u,v,w : RealType;
     fu,fv,fw,fx,x                          : RealType;
  label  20,40,50;
  begin
     c:=0.5*(3-sqrt(5));
     eps:=1;
     while 1+eps/2 <> 1 do eps:=eps/2;
     eps:=sqrt(eps);
     a:=ax; b:=bx; v:=a+c*(b-a);
     w:=v; x:=v;
     e:=0; fx:=f(x);
     fv:=fx; fw:=fx;
20:
     xm:=(a+b)/2;
     tol1:=eps*abs(x)+tol/3;
     tol2:=2*tol1;
     if abs(x-xm) <= tol2 -(b-a)/2 then
        begin
          Fmin:=x;
          exit;
        end;
     if abs(e) <= tol1 then goto 40;
     r:=(x-w)*(fx-fv);
     q:=(x-v)*(fx-fw);
     p:=(x-v)*q-(x-w)*r;
     q:=2*(q-r);
     if q > 0 then p:=-p;
     q:=abs(q);
     r:=e;
     e:=d;
     if (abs(p) >= abs(q*r/2)) or (p <= q*(a-x))
           or (p >= q*(b-x)) then goto 40;
     d:=p/q;
     u:=x+d;
     if (u-a < tol2) or (b-u < tol2) then d:=sign(tol1,xm-x);
     goto 50;
40:
     if x=xm then e:=a-x else e:=b-x;
     d:=c*e;
50:
     if abs(d) >= tol1 then u:=x+d else u:=x+sign(tol1,d);
     fu:=f(u);
     if fu<=fx then
        begin
           if u>= x then a:=x else b:=x;
           v:=w; fv:=fw;
           w:=x; fw:=fx;
           x:=u; fx:=fu;
           goto 20
        end; { if fu ... }
     if u < x then a:=u else b:=u;
     if (fu <= fw) or (w=x) then
        begin
           v:=w; fv:=fw;
           w:=u; fw:=fu
        end
      else
        if (fu <= fv) or (v=x) or (v=w) then
        begin
           v:=u; fv:=fu
        end;
      goto 20
  end { Fmin };
{ ======================== } END. { MinFun ======================== }
