{$N+,V-}
  UNIT KrilovU;

  interface

  USES Crt,Dos,Kernel;

  function Order10(x : RealType):longint;
  function Time: string;
  function Date: string;
  function ConvTime(time : DateTime) : string;
  function ConvertTime(t : DateTime):longint;
  procedure TimeXY(I,J : integer);
  procedure BoxXY(I,J : integer; st : string);
  procedure InvertTime(time : longint; var t : DateTime);
  procedure DeltaTime(t0,tk : DateTime; var DTime : DateTime);
  procedure ReadM(var a:RealType;numPos : integer; amin,amax:RealType);
  procedure ReadN(var a:integer;numPos : integer; amin,amax:integer);
  function amax(x1,x2 :RealType):RealType;
  function amin(x1,x2 :RealType):RealType;
  function imax(x1,x2 :integer):integer;
  function imin(x1,x2 :integer):integer;
  function sign(x1,x2 :RealType):RealType;
  function isign(x1,x2 :integer):integer;
  function sign1(x: RealType):RealType;
  function signInt(x: integer):integer;
  function sinc(x:RealType):RealType;
  function th(x:RealType):RealType;
  function log10(x:RealType):RealType;
  function tg(x:RealType):RealType;
  function sh(x:RealType):RealType;
  function ch(x:RealType):RealType;
  function K1(x:RealType):RealType;
  function K2(x:RealType):RealType;
  function K3(x:RealType):RealType;
  function K4(x:RealType):RealType;
  function ArcCos(x:RealType):RealType;
  function ArcSin(x:RealType):RealType;
  function arcch(x:RealType):RealType;
  procedure Box1XY(I,J : integer; st : string);
  procedure MarkOut(s : word);
  procedure InpXYM( X,Y,ColorT,ColorB    : Integer;
                           FrazaBeg            : string;
                           VarT                : RealType;
                           NumPos              : integer;
                           VarMin,VarMax       : Integer;
                           FrazaEnd            : string);

  procedure InpXYN( X,Y,ColorT,ColorB    : Integer;
                   FrazaBeg                    : string;
                   VarT,NumPos,VarMin,VarMax   : Integer;
                   FrazaEnd                    : string);

  procedure Detect_Size_Cursor;
  procedure TurnOff_On_Cursor(switch : boolean);
  procedure ActivePage(i:word);
  function Degree(x:RealType; i : integer):RealType;
  function Re(x: complex) : RealType;
  function Im(x: complex) : RealType;
  procedure Mod_Arg(x,y : RealType; var Modul,Fase : RealType);
  procedure Mdarg(xCos,ySin : RealType; var Modul,Fase : RealType);
  function Degr(M: RealType; E : RealType) : RealType;
  procedure DegMinSec(Degr10 : realType; var Degree, Min, Sec : integer);

  var
     UpGlobalCurs,DwGlobalCurs : byte;
  implementation
{-----------------------  begin block KRILOV  -----------------------------}

 function Order10(x : RealType):longint;
 var e  : longint;
     eps,xx : extended;
   begin
     eps:=1.0;
     while 1+eps <> 1 do eps:=eps/2;
     xx:=x;
     if xx=0 then begin Order10:=0; exit; end;
     if abs(xx) > 1 then
        begin
           e:=0;
           while not ((abs(xx) > 1.0+eps) and (abs(xx) <= 10-eps)) do
             begin
               xx:=xx*0.1;
               inc(e);
             end;
        end
     else
        begin
           e:=0;
           while not ((abs(xx) >= 1.0+eps) and (abs(xx) < 10-eps)) do
             begin
               xx:=xx*10;
               inc(e);
             end;
           e:=-e;
        end;
     Order10:=e;
  end; { Order10 }
{------------------------    21.08.90   ------------------------------------}
    function Date;
    var YearSt, MonthSt, DaySt   : string;
        Year,Month,Day,DayOfWeek : word;
      begin
         GetDate(Year,Month,Day,DayOfWeek);
         str(Year:4,YearSt);
         delete(YearSt,1,2);

         if Month < 10 then
            begin str(Month:1,MonthSt); MonthSt:='0'+MonthSt;end
         else str(Month:2,MonthSt);

         if Day < 10 then
            begin str(Day:1,daySt); DaySt:='0'+DaySt;end
         else str(Day:2,DaySt);

         Date:=daySt+'/'+MonthSt+'/'+YearSt;
      end; {DAte}
{-----------------------------------------------------------------------}
    function ConvTime(time : DateTime) : string;
    var HourSt, MinuteSt, SecondSt   : string;
    begin
       with time do
         begin
           if Hour < 10 then
              begin str(Hour:1,HourSt); HourSt:='0'+HourSt;end
           else str(Hour:2,HourSt);;

           if Min < 10 then
              begin str(Min:1,MinuteSt); MinuteSt:='0'+MinuteSt;end
            else str(Min:2,MinuteSt);;

            if Sec < 10 then
              begin str(Sec:1,SecondSt); SecondSt:='0'+SecondSt;end
            else str(Sec:2,SecondSt);;
          end;
       ConvTime:=HourSt+':'+MinuteSt+':'+SecondSt;
    end; {ConvTime}
{-------------------------------------------------------------------------}
    function Time: string;
    var TimeR     : DateTime;
        Sec100    : word;
      begin
         with timeR do GetTime(Hour,Min,Sec,Sec100);
         Time:=ConvTime(timeR);
      end; { Time }
{------------------------------------------------------------------------}
      function ConvertTime(t : DateTime):longint;
        var c:longint;
        begin
          c:=t.Hour;
          c:=3600*c;
          c:=c+60*t.Min;
          c:=c+t.sec;
          ConvertTime:=c;
        end;
{-------------------------------------------------------------------------}
      procedure InvertTime(time : longint; var t : DateTime);
        var Rest : longint;
        begin
          t.Hour:=time div 3600;
          Rest:=time mod 3600;
          t.Min:=Rest div 60;
          Rest:=Rest mod 60;
          t.sec:=Rest;
        end;

{-------------------------------------------------------------------------}
      procedure DeltaTime(t0,tk : DateTime; var DTime : DateTime);
      var t0s,tks,O                    : longint;
          HourSt, MinuteSt, SecondSt   : string;

      begin
         t0s:=ConvertTime(t0);
         tks:=ConvertTime(tk);
      { 室  ᫥騥 ⪨ }
         if tks < t0s then tks:=86400+tks;

{ ? }    DTime.Hour:=(tks-t0s) div 3600;
         O:=(tks-t0s) mod 3600;
         DTime.Min:=O div 60;
         DTime.Sec:= O mod 60;
      end;{ DeltaTime }
{----------------------------------------------------------------------------}
           procedure TimeXY(I,J : integer);
           var z1,z2 : word;
               Xcur,Ycur : word;
           begin
             XCur:=WhereX; Ycur:=WhereY;
             z1:= WindMax; z2:=WindMin;
             window(i,j,i+9,j);
             ClrScr;
             write(' ',time);
             WindMax:=z1; WindMin:=z2;
             gotoXY(XCur,YCur);
           end; {  TimeXY }
{---------------------------------------------------------------------------}
           procedure BoxXY(I,J : integer; st : string);
           var z1,z2,len,ix : word;
               Xcur,Ycur    : word;
           begin
             if ((i < 1) or (i > 78) or (j < 1) or (j > 25)) then exit;
             len:=Length(st);
             XCur:=WhereX; Ycur:=WhereY;
             z1:= WindMax; z2:=WindMin;
             ix:=i+len+1;
             if ix > 79 then ix:=79;
             window(i,j,ix,j);
             ClrScr;
             write(' ',st);
             WindMax:=z1; WindMin:=z2;
             gotoXY(XCur,YCur);
           end; {  BoxXY }
{---------------------------------------------------------------------------}
procedure ReadM(var a:RealType;numPos : integer; amin,amax:RealType);
var  IO : word;
     i,j,k : integer;
begin
  i:=WhereX; j:=WhereY;
  MarkOut(14);
  repeat
     gotoXY(i,j);
     for k:=1 to numPos do write(' ');
     gotoXY(i,j);
     {$I-}
     read(a);IO:=IOResult;
     {$I+}
     if IO <> 0 then writeln('IOResult=',IO);
  until (IO = 0) and (a>=amin) and (a<=amax);
  MarkOut(7);
end; {ReadM}

{-----------------------------------------------------------------}
procedure ReadN(var a:integer;numPos : integer; amin,amax:integer);
var  IO : word;
     i,j,k : integer;
begin
  i:=WhereX; j:=WhereY;
  MarkOut(14);
  repeat
     gotoXY(i,j);
     for k:=1 to numPos do write(' ');
     gotoXY(i,j);
     {$I-}
     read(a);IO:=IOResult;
     {$I+}
  until (IO = 0) and (a>=amin) and (a<=amax);
 MarkOut(7);
end; {ReadM}

        function amax(x1,x2 :RealType):RealType;
          begin
            if x1 > x2 then amax:=x1 else amax:=x2
          end;
        function amin(x1,x2 :RealType):RealType;
          begin
            if x1 < x2 then amin:=x1 else amin:=x2
          end;
        function imax(x1,x2 :integer):integer;
          begin
            if x1 > x2 then imax:=x1 else imax:=x2
          end;
        function imin(x1,x2 :integer):integer;
          begin
            if x1 < x2 then imin:=x1 else imin:=x2
          end;

        function sign(x1,x2 :RealType):RealType;
          begin
            if x2=0 then sign:=0
               else sign:=x2/abs(x2)*abs(x1);
          end;
        function isign(x1,x2 :integer):integer;
          begin
            if x2=0 then isign:=0
               else isign:=x2 div abs(x2)*abs(x1);
          end;
        function sign1(x: RealType):RealType;
          begin
            if x=0 then sign1:=0
               else if x < 0 then sign1:=-1 else sign1:=+1;
          end;
        function signInt(x: integer):integer;
          begin
            if x=0 then signInt:=0
               else if x < 0 then signInt:=-1 else signInt:=+1;
          end;
        function tg(x:RealType):RealType;
          begin
            tg:=sin(x)/cos(x);
          end;
        function log10(x:RealType):RealType;
          begin
            log10:=ln(x)/ln(10); { exp(0); }
          end;

        function th(x:RealType):RealType;
          begin
            th:=(exp(x)-exp(-x))/(exp(x)+exp(-x));
          end;
        function sh(x:RealType):RealType;
          begin
            sh:=0.5*(exp(x)-exp(-x));
          end;
        function ch(x:RealType):RealType;
          begin
            ch:=0.5*(exp(x)+exp(-x));
          end;
        function K1(x:RealType):RealType;
          begin
            K1:=0.5*(cos(x)+ch(x));
          end;
        function K2(x:RealType):RealType;
          begin
            K2:=0.5*(sin(x)+sh(x));
          end;
        function K3(x:RealType):RealType;
          begin
            K3:=0.5*(ch(x)-cos(x));
          end;
        function K4(x:RealType):RealType;
          begin
            K4:=0.5*(sh(x)-sin(x));
          end;
function sinc(x:RealType):RealType;
begin
   if x=0 then sinc:=1 else sinc:=sin(x)/x;
end;
        function ArcSin(x:RealType):RealType;
          begin
            if abs(x) > 1 then begin writeln(#7'ArcSin does not exist !');
               exit; end;
            ArcSin:=arctan(x/sqrt(1-x*x));      { ⠫  3.06.93 }
          { 뫮 -  :=  pi/2-arcCos(x); }
          end;

        function ArcCos(x:RealType):RealType;
          begin
            if abs(x) > 1 then begin writeln(#7'ArcCos does not exist !');
               exit; end;
           { if (x > -0.1) and (x<1E-20)
              then ArcCos:=arctan(x/sqrt(1-x*x))
                else ArcCos:=arctan(sqrt(1-x*x)/x);   }
             if x=1 then arccos:=0 else ArcCos := pi/2-arcSin(x);
          end;

        function arcch(x:RealType):RealType;
          begin
             if x<1.0 then writeln('Arcch does not exist !!!');
               arcch:=ln(x+sqrt(sqr(x)-1));
          end;
     procedure Box1XY(I,J : integer; st : string);
     var z1,z2,len : word;
         Xcur,Ycur : word;
     begin
        len:=Length(st);
        XCur:=WhereX; Ycur:=WhereY;
        z1:= WindMax; z2:=WindMin;
        window(i,j,i+len,j);
        write(st);
        WindMax:=z1; WindMin:=z2;
        gotoXY(XCur,YCur);
     end; {  Box1XY }
{---------------------------------------------------------------------------}
procedure MarkOut(s : word);
var i,j : word;
begin
case LastMode of
 7: begin
      j:=0;
      case s of
     7: begin j:=0;i:=2 end;  { Norm }
     14: i:=10;                { Light }
     2: i:=26;                { Light + blink }
     3: i:=20;                { LowVideo + blink }
     4: i:=1;                 { LowVideo + underLining }
     5: i:=9;                 { Ligth + underLining }
     6: i:=57;                { Ligth + underLining + blink }
     7: i:=17;                { LowVideo + underLining + blink }
     8: begin                 { InvertVideo }
           j:=15;i:=0;
        end;
      else i:=11;
      end; { case s }
    end;
  else
    case s of
0..7,9..15 : begin
              i:=s;
              j:=1;
             end;
         8:  begin j:=15; i:=0;end
    end { Case s }
  end; { case LastMode }
TextColor(i);
TextBackGround(j);
end; { MarkOut }
{---------------------------------------------------------------------------}
procedure InpXYM( X,Y,ColorT,ColorB    : Integer;
                   FrazaBeg            : string;
                   VarT                : RealType;
                   NumPos              : integer;
                   VarMin,VarMax       : Integer;
                   FrazaEnd            : string);

    var
         LnB,LnE           : word;
   begin
      LnB:=Length(FrazaBeg); LnE:=Length(FrazaEnd);
      GoToXY(X,Y); MarkOut(ColorT);Write(FrazaBeg);
      GoToXY(X+LnB+numPos,Y);
      Write(FrazaEnd);
      GoToXY(X+LnB,Y);MarkOut(ColorB);ReadM(VarT,numPos,VarMin,VarMax);
   end; { InpXYM }

procedure InpXYN( X,Y,ColorT,ColorB    : Integer;
                   FrazaBeg                    : string;
                   VarT,NumPos,VarMin,VarMax   : Integer;
                   FrazaEnd                    : string);
    var
         LnB,LnE   : word;
    begin
       LnB:=Length(FrazaBeg);LnE:=Length(FrazaEnd);
       GoToXY(X,Y);MarkOut(ColorT);Write(FrazaBeg);
       GoToXY(X+LnB+numPos,Y);
       Write(FrazaEnd);
       GoToXY(X+LnB,Y);MarkOut(ColorB);ReadN(VarT,numPos,VarMin,VarMax);
       MarkOut(ColorB); {  訩 ਠ,   ਡ ⥪
        䮭  室  楤, ⠪    ,
       樨  ᫮ ࠭稢  㦥   ,
       ४⭮ 室  X,Y  㬬୮  ࠧ  !!! }
    end;

{    InpXYM(20,5,7,14,'Impedance [0..1000] = ',a,4,0,1000,' kg/c/m');
    InpXYN(X,Y,ColorFraza,ColorInpt,'Def100=',Def100,
                    3,0,100,' %'); }

{-----------------------------------------------------------------}
  procedure Detect_Size_Cursor;
    var
      regs : Registers;
    begin
       regs.ah:=3;           { Return size of Cursor }
       Intr($10,regs);       { Call DOS }
       UpGlobalCurs:=regs.ch;
       DwGlobalCurs:=regs.cl;
    end;

  procedure TurnOff_On_Cursor(switch : boolean);
    var
      regs : Registers;
    begin
      if  switch then
        begin
          regs.ah:=1;                      { Set Size of Cursor }
          regs.ch:=$20; { 14;}
          regs.cl:=$00;  { 14; }
          Intr($10,regs);                  { Call DOS }
        end
      else
        begin
          regs.ah:=1;
          regs.ch:=UpGlobalCurs;
          regs.cl:=DwGlobalCurs;
          Intr($10,regs);                  { Call DOS }
        end;
    end; { TurnOff_On_Cursor }

procedure ActivePage(i:word);
var
  regs                : Registers;
  begin
    regs.AH:=5; regs.AL:=i;
    Intr($10,regs); { i - active Page }
  end;


 function Degree(x:RealType; i : integer):RealType;
   var j : integer;
       Deg : RealType;
   begin
     if x=0 then begin Degree:=0; exit end;
     if i=0 then begin Degree:=1; exit end;
     if i >= 1 then
       begin
         Deg:=1;
         for j:=1 to i do
            Deg:=deg*x;
       end;
     if i < 0 then
       begin
         Deg:=1; i:=abs(i);
         for j:=1 to i do
            Deg:=deg*x;
         Deg:=1/Deg;
       end;
       Degree:=Deg;
    end; { degree }

    function Re(x: complex) : RealType;
      begin
        Re:=x[1]
      end;

    function Im(x: complex) : RealType;
      begin
        Im:=x[2];
      end;
{ ----------------------- 23.01.92 ----------------------------------- }
     procedure Mod_Arg(x,y : RealType; var Modul,Fase : RealType);
     begin
       Modul:=sqrt(x*x+y*y);
       fase:=pi/2;
       if x=0 then exit;
       fase:=arcTan(y/x);
       if x >= 0 then exit;
       if ( x < 0) and ( y >= 0) then fase:=fase+pi else fase:=fase-pi;
     end; { Mdarg2 }
{ ------------------------------ 26.01.91 ----------------------------------- }
     procedure Mdarg(xCos,ySin : RealType; var Modul,Fase : RealType);
     begin
       Modul:=sqrt(xCos*xCos+ySin*ySin);
       fase:=pi/2;
       if ySin=0 then exit;
       fase:=arcTan(xCos/ySin);
       if ySin >= 0 then exit;
       if ( ySin < 0) and ( xCos >= 0) then fase:=fase+pi else fase:=fase-pi;
     end; { Mdarg }
{--------------------end ins 26.06.89---------------------------------------}

{---------------------------------------------------------------------- }

    function Degr(M: RealType; E : RealType) : RealType;
      begin
        { Degr:=M^E calculated }
          if M <= 0 then
             begin
               writeln('DATA in DEGR is not correct !!!');
               Degr:=0;
               exit;
             end;
          Degr:=exp(E*Ln(M));
      end;
    procedure DegMinSec(Degr10 : realType; var Degree, Min, Sec : integer);
    var MinR,SecR,sig : single;
    begin
      sig:=Sign1(Degr10);
      Degr10:=abs(Degr10);
      MinR:=60*(Degr10-trunc(Degr10)); Min:=Trunc(MinR);
      SecR:=60*(MinR-MinR);
      Sec:=round(SecR);
      Degr10:=Degr10*sig;
    end; { DegMinSec }
{---------------------------------------------------------------------------}
    end.
{---------------------------  end block KRILOV   -----------------------------}