Unit Quanc8U;
             INTERFACE
{$N+,E+,F+}
USES Kernel;
type
   FunType = Function(x: RealType): RealType;
Procedure Quanc8(Fun : FunType;
                  A,B, AbsErr, RelErr : RealType;
                  var Result, ErrEst : RealType;
                  var NoFun : integer; var Flag : RealType );

             IMPLEMENTATION
 function Amax1(x,y : RealType) : RealType;
 begin
    if x > y then Amax1:=x else Amax1:=y;
 end;

 Procedure Quanc8(Fun : FunType;
                  A,B, AbsErr, RelErr : RealType;
                  var Result, ErrEst : RealType;
                  var NoFun : integer; var Flag : RealType );
 Const
    ww =14175;
 var w0,w1,w2,w3,w4,Area,x0,f0,stone,Step,Cor11,Temp,
     qprev,qnow,qdiff,qleft,esterr,tolerr             : RealType;
     qright                                : array[1..31] of RealType;
     f,x                                   : array[1..16] of RealType;
     fsave,xsave                           : array[1..8,1..30] of RealType;
     levmin,levmax,levout,
     nomax,nofin,lev,nim,i,j               : integer;
 label 30,50,60,62,70;
 Begin
    Levmin:=1; Levmax:=30; Levout:=6; nomax:=5000;
    nofin:=nomax-8*(levmax-levout+round(exp((levout+1)*ln(2))));
    w0:=3956/ww; w1:=23552/ww; w2:=-3712/ww; w3:=41984/ww;
    w4:=-18160/ww;
    Flag:=0; Result:=0; cor11:=0; ErrEst:=0; Area:=0; NoFun:=0;
    if A=B then exit;
    lev:=0; nim:=1; x0:=A; X[16]:=B;
    qprev:=0; f0:=Fun(x0);
    stone:=(B-A)/16;
    X[8]:=(x0+X[16])/2;
    X[4]:=(x0+X[8])/2;
    X[12]:=(X[8]+X[16])/2;
    X[2]:=(x0+X[4])/2;
    X[6]:=(X[4]+X[8])/2;
    X[10]:=(X[8]+X[12])/2;
    X[14]:=(X[12]+X[16])/2;
    FOR j:=2 to 16 do
      if not odd(j) then F[j]:=Fun(X[j]);
    noFun:=9;
30: X[1]:=(x0+X[2])/2;
    F[1]:=Fun(X[1]);
    for j:=3 to 15 do if odd(j) then
      begin
         X[j]:=(X[j-1]+X[j+1])/2;
         F[j]:=Fun(X[j]);
      end;
    NoFun:=NoFun+8;
    Step:=(X[16]-x0)/16;
    qleft:=(w0*(f0+F[8])+w1*(F[1]+F[7])+w2*(F[2]+F[6])+
            w3*(F[3]+F[5])+w4*F[4])*Step;
    qright[lev+1]:=(w0*(F[8]+F[16])+w1*(F[9]+F[15])+
            w2*(F[10]+F[14])+w3*(F[11]+F[13])+w4*F[12])*step;
    qnow:=qleft+qright[lev+1];
    qdiff:=qnow-qprev;
    area:=area+qdiff;
    estErr:=abs(qdiff)/1023;
    tolerr:=Amax1(AbsErr,RelErr*Abs(area))*(Step/stone);
    if lev < levmin then goto 50;
    if lev >= levmax then goto 62;
    if NoFun > nofin then goto 60;
    if esterr <= tolerr then goto 70;
50: Nim:=2*nim; lev:=lev+1;
    for i:=1 to 8 do
      begin
         fsave[i,lev]:=F[i+8];
         xsave[i,lev]:=X[i+8];
      end;
    qprev:=qleft;
    for i:=1 to 8 do
       begin
          j:=-i;
          F[2*j+18]:=F[j+9];
          X[2*j+18]:=X[j+9];
       end;
    goto 30;
60: nofin:=2*nofin;
    levmax:=levout;
    Flag:=Flag+(B-x0)/(B-A);
    goto 70;
62: Flag:=Flag+1;
70: Result:=Result+qnow;
    ErrEst:=ErrEst+esterr;
    cor11:=cor11+qdiff/1023;
    while nim <> 2*(nim div 2 ) do
      begin
         nim:=nim div 2;
         lev:=lev-1;
      end;
    nim:=nim+1;
    if lev > 0 then
      begin
         qprev:=qright[lev];
         x0:=X[16]; f0:=F[16];
         for i:=1 to 8 do
           begin
              F[2*i]:=fsave[i,lev];
              X[2*i]:=xsave[i,lev];
           end;
         goto 30;
      end; { if lev }
    Result:=Result+cor11;
    if ErrEst = 0 then exit;
    repeat
       temp:=abs(Result)+ErrEst;
       if temp <> abs(Result) then exit;
       ErrEst:=2*Errest;
    until false;
  end { Quanc8 };
END.

