UNIT RKF45U;
{ ---------------------  15.04.91 ---------------------------------------- }
                           INTERFACE
{$N+,E+,F+}
USES Kernel,KrilovU;
Type
  ProcType = procedure ( T : RealType; var YI; n : integer; var YPI);

{------------------adopted by Kvashnin S.E. 10.04.88  ------------------------}

  procedure RKF45(Fex : ProcType; neqn : integer; var YI; var h,t,tout,relerr,
                   abserr : realType;
                   var iflag,nfe,kop,init,jflag,kflag : integer;
                   var ypI,f1I,f2I,f3I,f4I,f5I;
                   var savre, savae : RealType);

                         IMPLEMENTATION
  FUNCTION AMax ( x,y : RealType ) : RealType;
  begin
    if x> y then Amax:=x else Amax:=y
  end;

  procedure RKF45(Fex : ProcType; neqn : integer; var YI; var h,t,tout,relerr,
                   abserr : realType;
                   var iflag,nfe,kop,init,jflag,kflag : integer;
                   var ypI,f1I,f2I,f3I,f4I,f5I;
                   var savre, savae : RealType);

  const MaxNfe=3000; Remin=1E-12;
  label 5,10,20,25,30,40,45,50,55,60,65,70,80,85,95,100,150,200,220,240,
        260,300, ret;
  var
      hfaild, output1                              : boolean;
      a,ae,dt,ee,eeoet,esttol,et,hmin              : RealType;
      rer,s,scale,tol,toln,u26,epsp1,eps,ypk       : RealType;
      k,mflag                                      : integer;
      amax1,amin1,hdop                             : RealType;
      y  : RealTypeArray absolute YI;
      yp : RealTypeArray absolute YpI;
      f1 : RealTypeArray absolute f1I;
      f2 : RealTypeArray absolute f2I;
      f3 : RealTypeArray absolute f3I;
      f4 : RealTypeArray absolute f4I;
      f5 : RealTypeArray absolute f5I;
{----------------------------------------------------------------------------}
   procedure Fehl(Fex : ProcType; neqn: integer; var y1;  t,h : realType;
                            var yp1,f11,f21,f31,f41,f51,s1);
   var ch          : realType;
        k          : integer;
        y  : RealTypeArray absolute Y1;
        yp : RealTypeArray absolute Yp1;
        f1 : RealTypeArray absolute f11;
        f2 : RealTypeArray absolute f21;
        f3 : RealTypeArray absolute f31;
        f4 : RealTypeArray absolute f41;
        f5 : RealTypeArray absolute f51;
        s  : RealTypeArray absolute s1;
     begin

       ch:=h/4.0;
       for k:=1 to neqn do f5[k]:=y[k]+ch*yp[k];
       Fex(t+ch,f5,NEQN,f1);

       ch:=3.0*h/32.0;
       for k:=1 to neqn do f5[k]:=y[k]+ch*(yp[k]+3.0*f1[k]);
       Fex(t+3.0*h/8.0,f5,neqn,f2);

       ch:=h/2197.0;
       for k:=1 to neqn do f5[k]:=y[k]+ch*(1932.0*yp[k]+
                                  (7296.0*f2[k]-7200.0*f1[k]));
       Fex(t+12.0*h/13.0,f5,neqn,f3);

       ch:=h/4104.0;
       for k:=1 to neqn do f5[k]:=y[k]+ch*((8341.0*yp[k]-845.0*f3[k])+
                                  (29440.0*f2[k]-32832.0*f1[k]));
       Fex(t+h,f5,neqn,f4);

       ch:=h/20520.0;
       for k:=1 to neqn do f1[k]:=y[k]+ch*((-6080.0*yp[k]+(9295.0*f3[k]-
                  5643.0*f4[k]))+(41040.0*f1[k]-28352.0*f2[k]));
       Fex(t+h/2.0,f1,neqn,f5);
       ch:=h/7618050.0;
       for k:=1 to neqn do
         s[k]:=y[k]+ch*((902880.0*yp[k]+(3855735.0*f3[k]-1371249.0*f4[k]))+
               (3953664.0*f2[k]+277020.0*f5[k]));

  end; { Fehl }
{---------------------------------------------------------------------------}
  begin
     if neqn < 1 then goto 10;
     if (relerr < 0) or (abserr < 0.0) then goto 10;
     mflag:=abs(iflag);
     if (mflag=0) or (mflag > 8) then goto 10;
     if mflag<> 1 then goto 20;
{ first call, calculated epsilon }
     eps:=1.0;
5:   eps:=eps/2.0;
     epsp1:=eps+1.0;
     if epsp1 > 1.0 then goto 5;
     u26:=26.0*eps;
     goto 50;

{    error into the input informaton   }
10:  iflag:=8;goto ret;
20:  if (t=tout) and (kflag <> 3) then goto 10;
     if mflag <> 2 then goto 25;

     if (kflag=3) or (init=0) then goto 45;
     if kflag=4 then goto 40;

     if (kflag=5) and (abserr=0) then goto 30;
     if (kflag=6) and (relerr<=savre) and (abserr <= savae) then goto 30;
     goto 50;

25:
     if iflag=3 then goto 45;
     if iflag=4 then goto 40;
     if(iflag=5) and (abserr> 0.0) then goto 45;

30:  goto ret; {stop????}

40:  nfe:=0;
     if mflag=2 then goto 50;
45:  iflag:=jflag;
     if kflag=3 then mflag:=abs(iflag);

50:  jflag:=iflag;
     kflag:=0;

     savre:=relerr; savae:=abserr;

     rer:=2.0*eps+remin;
     if relerr >= rer then goto 55;

     relerr:=rer;iflag:=3; kflag:=3;goto ret;

55:  dt:=tout-t;
     if mflag=1 then goto 60;
     if init=0 then goto 65;
     goto 80;


60:  init:=0; kop:=0; a:=t;
     Fex(a,y,neqn,yp);
     nfe:=1;
     if t<> tout then goto 65;
     iflag:=2; goto ret;

65:  init:=1; h:=abs(dt);toln:=0;
     for k:=1 to neqn do
       begin
         tol:=relerr*abs(y[k])+abserr;
         if tol <= 0 then goto 70;
         toln:=tol;
         ypk:=abs(yp[k]);
         if ypk*sqr(sqr(h))*h > tol then h:=exp(0.2*ln(tol/ypk));
   70: end;
     if toln <= 0 then h:=0.0;
     hdop:=u26*amax(abs(t),abs(dt));
     h:=amax(h,hdop);
     jflag:=isign(2,iflag);

80:  h:=sign(h,dt);
     if abs(h) >= 2.0*abs(dt) then kop:=kop+1;
     if kop <> 200 then goto 85;

     kop:=0;
     iflag:=7;goto ret;
85:  if abs(dt) > u26*abs(t) then goto 95;
     for k:=1 to neqn do y[k]:=y[k]+dt*yp[k];
     a:=tout;
     Fex(a,y,neqn,yp);
     nfe:=nfe+1;
     goto 300;


95:  output1:=false;
     scale:=2.0/relerr; ae:=scale*abserr;

100: hfaild:=false;
     hmin:=u26*abs(t);

     dt:=tout-t;
     if abs(dt)>= 2.0*abs(h) then goto 200;
     if abs(dt) > abs(h) then goto 150;
     output1:=true;
     h:=dt;goto 200;

150: h:=0.5*dt;
200: if nfe <= maxnfe then goto 220;
     iflag:=4; kflag:=4; goto ret;

220: Fehl(Fex,neqn,y,t,h,yp,f1,f2,f3,f4,f5,f1);
     nfe:=nfe+5;
     eeoet:=0.0;

     for k:= 1 to neqn do
       begin
         et:=abs(y[k])+abs(f1[k])+ae;
         if et > 0.0 then goto 240;
         iflag:=5; goto ret;
240:     ee:=abs((-2090.0*yp[k]+(21970.0*f3[k]-15048.0*f4[k]))+
            (22528.0*f2[k]-27360.0*f5[k]));
         eeoet:=amax(eeoet,ee/et);
       end;
     esttol:=abs(h)*eeoet*scale/752400.0;
     if esttol <= 1.0 then goto 260;
     hfaild:=true;
     output1:=false;
     s:=0.1;
     if esttol < 59049.0 then s:=0.9/exp(0.2*ln(esttol));
     h:=s*h;
     if abs(h) > hmin then goto 200;
     iflag:=6; kflag:=6; goto ret;

260: t:=t+h;
     for k:=1 to neqn do
       y[k]:=f1[k];
     a:=t;
     Fex(a,y,neqn,yp);
     nfe:=nfe+1;
     s:=5.0;
     if esttol > 1.889568E-4  then s:=0.9/exp(0.2*ln(esttol));
     if hfaild then s:=amin(s,1.0);
     h:=sign(amax(s*abs(h),hmin),h);
     if output1 then goto 300;
     if iflag > 0 then goto 100;
     iflag:=-2;  goto ret;

300: t:=tout;
     iflag:=2; goto ret;
ret:
   end; { rkf45 }
begin
end.
{---------------------------------------------------------------------------}
